; Speaker demo by MetalMan (metallicas_world@hotmail.com)
; More information can be found at http://www.enkeladress.com/blitzspeaker.htm
; Make sure you unzipped the two files (speaker.dll, speaker.decls) to the Blitz
; userlib folder before you run this demo, else it won't compile.
; The userlib and demo can be distributed freely.
; Please send me a note if you like it or if you have any suggestions.
; More info can be found at: http://www.enkeladress.com/blitzspeaker.htm
; Cheers
; /MetalMan -2003
AppTitle "Speaker Demo"

Graphics 640,480,16,2
SetBuffer BackBuffer()

Function backtomenu()
 Print ""
 Print "Press a key to go back to the menu..."
 WaitKey
 FlushKeys() 
End Function 

Function CheckVoice()
 Cls
 Print "VoiceAvailable()"
 Print "Returns true if voice system is detected, false if not."
 Print "-------------------------------------------------------"
 Print "Result:"
 i%=VoiceAvailable() ; the userlib call
 Select i
  Case 1 Print "MS Speech engine detected on your system"
  Case 0 Print "MS Speech engine not available, this demo will not run correctly!!!"
 End Select
 Print ""
 backtomenu()
End Function

Function startvoice()
 Cls
 Print "InitVoice()"
 Print "If this command is not called before any other speech commands."
 Print "you will get runtime errors.
 Print "---------------------------------------------------------------"
 Print "Result:"
 InitVoice() ; the userlib call
 Print "If no error message has appeared then voice is initialized" 
 backtomenu()
End Function

Function Voices()
 Cls
 Print "GetVoiceCount(), GetVoiceName()"
 Print "Theese are the commands to call if you need to check"
 Print "wich voices that are available."
 Print "---------------------------------------------------------------"
 Print "Result:"
 VCount = GetVoiceCount() ; the userlib call
 For i%=0 To VCount - 1 ; VCount is zero indexed
	 Print i+"  -  "+GetVoiceName(i) 
 Next
 Print "The above are the voices available on your computer."
 backtomenu()
End Function

Function SetAVoice()
 Cls
 Print "SetVoice(VoiceIndex%)"
 Print "Call this function to set the active voice"
 Print "The integer parameter is a number between 0 - GetVoiceCount-1."
 Print "---------------------------------------------------------------"
 Print "Result:"
 VCount = GetVoiceCount() ; the userlib call
 For i%=0 To VCount - 1 ; VCount is zero indexed
	 Print i+"  -  "+GetVoiceName(i)  ; userlib call
 Next
 Print "Setting the voice to number "+(i-1)
 SetVoice(i-1)
 Say "Hello, this is "+GetVoiceName(i-1)
 backtomenu()
End Function

Function WaitDone()
 Cls
 Print "WaitUntilDone(ms%)"
 Print "This creates a delay in given milliseconds"
 Print "after the speech is done."
 Print "---------------------------------------------------------------"
 Print "Result: No call to userlib neccessary, play around with it yourself"
 backtomenu()
End Function

Function Speak()
 Cls
 Print "Say(Str$), SayAndWait(Str$), SpeakToFile(Str$,Filename$)"
 Print "Theese are the commands to call if for the actual"
 Print "audio output."
 Print "---------------------------------------------------------------"
 Print "Press a key to hear the voice"
 WaitKey
 FlushKeys()
 Print "Result: 1. Say('Hello, control is returned to you immediatley)"
 Say("Hello, control is returned To you immediatley") ; userlib call
 Print "Result: 2. SpeekToFile('c:\test.wav','I am a file residing in the root of your c drive.')"
 SpeakToFile("c:\test.wav","I am a file residing in the root of your c drive.")
 Print "Listen to the file c:\test.wav."
 Print "Result: 3. SayAndWait('Hello, this creates a delay in your code execution until the speech is done')"
 SayAndWait("Hello, this creates a Delay in your code execution Until the speech is done")
 backtomenu()
End Function


Function PauseResume()
 Cls
 Print "PauseVoice(), ResumeVoice()"
 Print "Pauses and resumes speech in process..."
 Print "---------------------------------------------------------------"
 Print "Result: Press a key to start voice"
 WaitKey 
 SetVoiceRate(-5)
 Say("This is a long sentance, press a key to pause it before I bore you to death with my bare voice")
 Print "Press a key to pause"
 WaitKey()
 PauseVoice()
 Print "Press a key to resume..."
 WaitKey()
 ResumeVoice()
 Print "Done."
 backtomenu()
End Function

Function volume()
 Cls
 Print "GetVoiceVolume%(), SetVoiceVolume(Vol%)"
 Print "Theese are the commands to call if you want to change"
 Print "the loudness of the speech."
 Print "---------------------------------------------------------------"
 Print "Press a key to start test:"
 WaitKey
 i% = GetVoiceVolume()
 Print "Current Volume: "+i
 SayAndWait("Current volume is: "+i)
 Print "Decreasing volume to half: "+Int(i / 2)
 SetVoiceVolume(Int(i / 2))
 Say("Now the volume is: "+(Int(i / 2))) 
 backtomenu()
End Function

Function VoiceRate()
 Cls
 Print "GetVoiceRate%(), SetVoiceRate(Rate%)"
 Print "Theese are the commands to call if you want to change"
 Print "the speed of the speech."
 Print "---------------------------------------------------------------"
 Print "Press a key to start test:"
 WaitKey
 i% = GetVoiceRate()
 Print "Current Rate: "+i
 SayAndWait("Current rate is: "+i)
 Print "Increasing rate to: "+(i+5)
 SetVoiceRate(i+5)
 Say("Now the rate is: "+(i+5)) 
 
 backtomenu()
End Function


Function VoiceState()
 Cls
 Print "GetVoiceState%()"
 Print "Returns 0 if voice is quiet, 1 if voice is currently holding a"
 Print "the speed of the speech."
 Print "---------------------------------------------------------------"
 Print "Press a key to start test:"
 WaitKey
 SetVoiceRate(-5)
 Say("I am now speaking, and if you look at the text below you can see it's true!")
 i%=GetVoiceState()
 FlushKeys()
 Repeat
  i%=GetVoiceState()  
  ;Locate 60,80
  Color 0,0,0
  Rect 60,80,300,130
  Color 255,255,255
  Select i
	Case 0 Print "Silent. Press a key to abort."
	Case 1 Print "Speaking. Press a key to abort."
  End Select
 Until (GetKey()) 
 backtomenu()
End Function

; A simple menu function
Function menu()
done%=False
Repeat
 ;Locate 0,0
 Cls
 Print "This demo will guide you through all the commands available in"
 Print "this current version of Speaker.dll."
 Print "Press a key (0..9) to test the function."
 Print "******************************************************************"
 Print "1. VoiceAvailable()   - Test if the MS Speech engine is installed."
 Print "2. InitVoice() - Initialize the speech engine."
 Print "3. GetVoiceCount(), GetVoiceName() - Check wich voices are available"
 Print "4. SetVoice() - Set the speaker voice"
 Print "5. WaitUntilDone() - Set the ammount of time before control is returned to you"
 Print "6. Say(), SayAndWait(), SpeakToFile() - The actual speak commands"
 Print "7. PauseVoice(), ResumeVoice() - Pauses and resumes the speech"
 Print "8. SetVoiceRate(), GetVoiceRate() - Set/Get the speed of the speech"
 Print "9. GetVoiceState() - Is he currently talking or what?"
 Print "0. GetVoiceVolume(), SetVoiceVolume() - The volume of speech"
 Print "Esc. Quit the demo"
 Print ""
 ;Locate 0,0
 While Not GetKey()
 Wend
 If KeyDown(1) Then
	done=True
 Else If KeyDown(2) Then
	checkvoice()
 Else If KeyDown(3) Then
    StartVoice()
 Else If KeyDown(4) Then
    Voices()
 Else If KeyDown(5) Then
    SetAVoice()
 Else If KeyDown(6) Then
	WaitDone()
 Else If KeyDown(7)
    Speak()
 Else If KeyDown(8) Then
	PauseResume()
 Else If KeyDown(9) Then
	VoiceRate()
 Else If KeyDown(10) Then
	VoiceState()
 Else If KeyDown(11) Then
   Volume()
 End If 
Until done%=True 
End Function


menu()
FreeVoice() ; to make sure the voice object is freed.